package com.lyg.application.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.*;
import java.io.Serializable;
import java.time.LocalDateTime;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import javax.validation.constraints.NotBlank;

/**
 * 不相容;
 * @author : http://www.chiner.pro
 * @date : 2024-3-6
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "不相容",description = "")
@TableName("ta_incompatible")
public class TaIncompatible implements Serializable,Cloneable{

    @ApiModelProperty(name = "不相容Id",notes = "")
    @TableId(value = "incompatible_id", type = IdType.ASSIGN_UUID)
    private String incompatibleId ;

    @ApiModelProperty(name = "原岗位",notes = "")
    private String primaryPost ;

    @ApiModelProperty(name = "目标岗位",notes = "")
    private String targetPost ;

    @ApiModelProperty(name = "规则 普通规则 regularRules,三个月规则 monthRules",notes = "")
    private String rule ;

    @ApiModelProperty(name = "状态",notes = "")
    private Integer status ;

    @ApiModelProperty(name = "创建人",notes = "")
    @TableField(fill = FieldFill.INSERT)
    private String createUser ;

    @ApiModelProperty(name = "创建时间",notes = "")
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createDate ;

    @ApiModelProperty(name = "更新人",notes = "")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateUser ;

    @ApiModelProperty(name = "更新时间",notes = "")
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateDate ;

    @ApiModelProperty(name = "删除标志",notes = "1删除")
    @TableField(fill = FieldFill.INSERT)
    private Integer deleted ;

}