package com.lyg.application.util;


import cn.dev33.satoken.util.SaResult;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lyg.application.entity.TaIncompatible;
import com.lyg.application.entity.TaRotation;
import com.lyg.application.mapper.TaIncompatibleMapper;
import com.lyg.application.mapper.TaRotationMapper;
import com.lyg.common.Constants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

@Component
public class Rule {


    @Autowired
    TaIncompatibleMapper taIncompatibleMapper;
    @Autowired
    TaRotationMapper taRotationMapper;


    //这是在controller中使用的
    public Object taRotationRule(TaRotation taRotation) {
        Map<String, String> params = new Hashtable<>();
        String specificOrgName = taRotation.getSpecificOrgName();
        String specificNameOrgRotation = taRotation.getSpecificNameOrgRotation();
        String counterImpPositions = taRotation.getCounterImpPositions();
        String counterImpPostRotation = taRotation.getCounterImpPostRotation();

        if (specificOrgName != null && specificNameOrgRotation != null && counterImpPositions != null && counterImpPostRotation != null) {
            LocalDate newDate = LocalDate.now();
            DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
            String passTime = newDate.format(formatter);
            params.put("oldOrgCode", taRotation.getSpecificOrgName());
            params.put("newOrgCode", taRotation.getSpecificNameOrgRotation());
            params.put("primaryPost", taRotation.getCounterImpPositions());
            params.put("targetPost", taRotation.getCounterImpPostRotation());
            params.put("passTime", passTime);


            Object result = siftRule(params);

            return result;
        }
        return taRotation;
    }


    public Object siftRule(Map<String, String> params) {
        String oldOrgCode = params.get("oldOrgCode");
        String newOrgCode = params.get("newOrgCode");
        String primaryPost = params.get("primaryPost");
        String targetPost = params.get("targetPost");
        String passTime = params.get("passTime");

        //普通规则
        if (oldOrgCode.equals(newOrgCode)) {
            List<TaIncompatible> taIncompatibleList = regularRules(primaryPost, targetPost);

//                List<TaIncompatible> taIncompatibleList = taIncompatibleService.getRegularRules(, );

            if (taIncompatibleList.size() == 0) {
                return "普通规则:根据不相容设置这两个岗位是相容的";
            } else {
                return taIncompatibleList;
            }

        } else {
            params.put("oldOrgCode", oldOrgCode);
            params.put("newOrgCode", newOrgCode);
            params.put("primaryPost", primaryPost);
            params.put("targetPost", targetPost);
            params.put("passTime", passTime);
            //三个月规则
            List<TaRotation> repelList = getMonthRules(params);
//                List<TaRotation> repelList = taIncompatibleService.getMonthRules(params);
            if (repelList.size() == 0) {
                return "三个月规则: 这是两个岗位是相容的";
            } else {
                return repelList;
            }

        }

    }


    public List<TaIncompatible> regularRules(String primaryPost, String targetPost) {
        return taIncompatibleMapper.getRegularRules(primaryPost, targetPost, Constants.REGULAR_RULE);

    }


    public List<TaRotation> getMonthRules(Map<String, String> params) {
        List<TaRotation> repelList = new ArrayList<>();

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        String primaryPost = params.get("primaryPost");
        String targetPost = params.get("targetPost");
        String passTime = params.get("passTime");
        LocalDate newDate = LocalDate.parse(passTime, formatter).minusMonths(3);

        List<String> oldPostList = taIncompatibleMapper.getMonthRulesPrimary(primaryPost, Constants.MONTH_RULE);
        List<String> newPostList = taIncompatibleMapper.getMonthRulesTarget(targetPost, Constants.MONTH_RULE);

        if (oldPostList.size() == 0 && newPostList.size() == 0) {
            return repelList;
        } else {
            List<String> orgList = newPostList;//原来岗位+目标不相容岗位
            orgList.add(primaryPost);

            List<String> targetList = oldPostList;//目标岗位+原来不相容岗位
            targetList.add(targetPost);

            //                拿到数据 不相容轮岗数据
            repelList = taRotationMapper.selectRepel(orgList, targetList, newDate);

            return repelList;
        }
    }
}

