package com.lyg.framework.accesslimit;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class IntercepterConfig implements WebMvcConfigurer {

    @Autowired
    private AccessLimitInterceptor accessLimitInterceptor;

    @Value("${access-limit.enabled}")
    Boolean enabled;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        if (null != enabled && enabled) {
            registry.addInterceptor(accessLimitInterceptor)
                    .addPathPatterns("/**");
        }
    }
}
