package com.lyg.framework.exception;

import cn.dev33.satoken.exception.SaTokenException;
import cn.dev33.satoken.util.SaResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import java.util.List;

@Slf4j
@RestControllerAdvice
public class GlobalExceptionHandler {

    @ResponseBody
    @ExceptionHandler(SaTokenException.class)
    public SaResult handleSaTokenException(Exception e){
        e.printStackTrace();
        return SaResult.error(e.getMessage());
    }

    @ResponseBody
    @ExceptionHandler(Exception.class)
    public SaResult handleException(Exception e){
        e.printStackTrace();
        return SaResult.error(e.getMessage());
    }

    @ResponseBody
    @ExceptionHandler(MethodArgumentNotValidException.class)
    public SaResult handleValidException(MethodArgumentNotValidException e) {
        e.printStackTrace();

        List<ObjectError> allErrors = e.getBindingResult().getAllErrors();
        ObjectError err = allErrors.get(0);

        return SaResult.error(err.getDefaultMessage());
    }
}
