package com.lyg.framework.satoken;

import cn.dev33.satoken.stp.StpUtil;
import com.lyg.framework.service.IUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.servlet.*;
import java.io.IOException;

/**
 * 比 SaServletFilter 的排序大即可
     * SaServletFilter 的默认排序是负数
 * 主要作用附加当前用户信息
 */
@Order(1)
@Component
public class SaServletFilter2 implements Filter {

    @Autowired
    IUserService userService;

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        // 只有登录之后才行
        if (StpUtil.isLogin()) {
            appendUser(servletRequest);
        }

        //
        filterChain.doFilter(servletRequest, servletResponse);
    }

    private void appendUser(ServletRequest request) {
        Object user = userService.getUserBy(StpUtil.getLoginId());
        if (null != user) {
            request.setAttribute("user", user);
        }
        request.setAttribute("tenantId", userService.getTenantIdBy(user));
    }
}
