package com.lyg.system.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.lyg.common.Constants;
import com.lyg.system.entity.SysMenu;
import com.lyg.system.mapper.SysMenuMapper;
import com.lyg.system.service.SysMenuService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 菜单表;(sys_menu)表服务实现类
 *
 * @author : http://www.chiner.pro
 * @date : 2023-2-5
 */
@Service
public class SysMenuServiceImpl extends BaseServiceImpl<SysMenuMapper, SysMenu> implements SysMenuService {

    @Override
    public List<SysMenu> getByUser(String userId) {
        if (Constants.ROOT_ID.equals(userId)) {
            QueryWrapper<SysMenu> queryWrapper = new QueryWrapper<>();
            queryWrapper.gt("status", Constants.STATUS_DELETE);
            return list(queryWrapper);
        }

        return baseMapper.getByUser(userId);
    }

    @Override
    public List<String> getIdListByUser(String userId) {
        List<SysMenu> list = getByUser(userId);
        return null == list
                ? new ArrayList<>()
                : list.stream().map(SysMenu::getMenuId).collect(Collectors.toList());
    }
}