package com.lyg.system.service.impl;

import com.lyg.system.entity.SysRoleResource;
import com.lyg.system.mapper.SysRoleResourceMapper;
import com.lyg.system.service.SysRoleResourceService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 角色资源;(sys_role_resource)表服务实现类
 *
 * @author : http://www.chiner.pro
 * @date : 2023-2-5
 */
@Service
public class SysRoleResourceServiceImpl extends BaseServiceImpl<SysRoleResourceMapper, SysRoleResource> implements SysRoleResourceService {

    @Override
    public void mergeData(String roleId, List<SysRoleResource> roleResourcesList) {
        // 如果是空 list, 代表取消授权
        if (roleResourcesList.size() == 0) {
            removeByMap(new HashMap<String, Object>(){{
                put("role_id", roleId);
            }});
            return ;
        }

        //
        List<String> idList = new ArrayList<>();
        for (SysRoleResource item: roleResourcesList) {
            item.setRoleId(roleId);

            SysRoleResource origin = baseMapper.getByRoleAndResource(roleId, item.getResourceId(), item.getResourceType());
            if (null != origin) {
                item.setId(origin.getId());
            } else {
                baseMapper.insert(item);
            }

            idList.add(item.getId());
        }

        // 删除多余的数据
        baseMapper.deleteNotIn(roleId, idList);

    }

    @Override
    public SysRoleResource getByRoleAndResource(String roleId, String resourceId, String resourceType) {
        return baseMapper.getByRoleAndResource(roleId, resourceId, resourceType);
    }
}